/*
	LUSScreenSaver
	Copyright (C) 2004 ONO, Masayuki <mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _LESS_UNSATICEFACTORY_SCREENSAVER_H_
#define _LESS_UNSATICEFACTORY_SCREENSAVER_H_

#include <qstring.h>
#include <qobject.h>
#include <qfile.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qmessagebox.h>
#include <qtimer.h>
#include <qwindowsystem_qws.h>
#include <qpe/qlibrary.h>
#include <qpe/qcopenvelope_qws.h>
#include <qpe/qpeapplication.h>
#include <qpe/global.h>
#include <qobjectlist.h>
#include <qwidgetlist.h>

class LUSScreenSaverWidget;
class LUSPassInputDlg;

class LUSScreenSaver : public QObject, public QWSScreenSaver
{
Q_OBJECT
public:
	LUSScreenSaver();
	virtual ~LUSScreenSaver();
	void restore();
	bool save( int );
	
	void VictimDlg();
	int ExecOKDlg( const char* );
	int ExecBaseDlg( const char* , int , int = QMessageBox::NoButton );
	void SetForceExecFlag();
	void UnsetWaitingLauncherFlag();
	bool IsWaitingLauncher();
	void SetScreenSaverMode( int );
	void AuthDone( int );
	void AuthDel();
	bool IsAppLocked();
	void DoLockedSuspend();
	void GetForeground();

protected slots:
	void ShowScreenSaver();

private:
	void RestartKeyHelper();
	void PauseKeyHelper();
	QLibrary* m_pSaver;
	QWidget* m_pSaverWidget;
	QLibrary* m_pAuthDlg;
	int m_bForceExecuted;
	int m_nDisableSuspend;
	int m_nDisableSuspendPre;
	int m_nTempMode;
	bool m_bWaitingLauncher;
};

#endif /* _LESS_UNSATICEFACTORY_SCREENSAVER_H_ */

