/*
	Authenticate Module for LUSScreenSaver
	Copyright (C) 2004 ONO, Masayuki <mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "LUSScreenSaverPassInputDlg.h"
#include "LUSScreenSaverAuth.h"
#include <qpe/global.h>
#include <qapplication.h>

LUSScreenSaverAuth::LUSScreenSaverAuth()
{
	ref = 0;
	m_nID = 0;
	m_pWidget = NULL;
}

LUSScreenSaverAuth::~LUSScreenSaverAuth(  )
{
	if ( m_pWidget )
	{
		delete m_pWidget;
	}
}

void LUSScreenSaverAuth::Start( int nID, bool bSuspendMode /* = FALSE */ )
{
	m_nID = nID;

	if ( ! m_pWidget )
	{
		m_pWidget = new LUSPassInputDlg( nID, NULL, "AuthDlg" );
		if ( bSuspendMode )
		{
			m_pWidget->SetSuspendMode();
		}
		m_pWidget->showFullScreen();
	}
	else
	{
		m_pWidget->ResetID( nID );
		m_pWidget->showNormal();
		m_pWidget->raise();
		m_pWidget->showFullScreen();
	}
}

bool LUSScreenSaverAuth::Stop( int nID )
{
	if ( m_nID == nID && m_pWidget )
	{
		delete m_pWidget;
		m_pWidget = NULL;
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

void LUSScreenSaverAuth::Delete()
{
	if ( m_pWidget )
	{
		delete m_pWidget;
		m_pWidget = NULL;
	}
}

QRESULT LUSScreenSaverAuth::queryInterface(const QUuid& uuid,
	QUnknownInterface** iface)
{
	*iface = 0;
	if(uuid == IID_QUnknown)
	{
		*iface = this;
	}
	else if ( uuid == IID_LUSScreenSaver )
	{
		*iface = this;
	}

	if(*iface)
	{
		(*iface)->addRef();
	}

	return QS_OK;
}

Q_EXPORT_INTERFACE()
{
	Q_CREATE_INSTANCE( LUSScreenSaverAuth )
}
