/*
	Authenticate Module For LUSScreenSaver
	Copyright (C) 2004 ONO, Masayuki <mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _LESS_UNSATICEFACTORY_SCREENSAVER_PASS_INPUT_DLG_H_
#define _LESS_UNSATICEFACTORY_SCREENSAVER_PASS_INPUT_DLG_H_

#include <qwidget.h>
#include <qtimer.h>
#include <qframe.h>
#include <qlayout.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qwindowsystem_qws.h>
#include <qpe/config.h>
#include <qpe/global.h>
#include <qpe/qcopenvelope_qws.h>
#include <qpe/qpeapplication.h>

class LUSPassInputDlg : public QWidget
{
	Q_OBJECT
public:
	// Public Methods
	LUSPassInputDlg( int, QWidget* = 0, const char* = 0 );
	virtual ~LUSPassInputDlg();
	void ResetID( int );
	void SetSuspendMode();

	// GUI WIdgets
	QFrame*      BaseWidget;
	QLabel*      PassLabel;
	QLineEdit*   PassEdit;
	QPushButton* OkButton;
	QPushButton* CancelButton;

protected:
	// GUI Layouts
	QHBoxLayout* EmptyLayout;
	QVBoxLayout* BaseLayout;
	QHBoxLayout* ButtonsLayout;
	QCopChannel* m_pSysChannel;

	// Protected Methods
	void focusInEvent( QFocusEvent* );
	void closeEvent( QCloseEvent* );
	void resizeEvent( QResizeEvent* );
	void keyPressEvent( QKeyEvent* );
	void keyReleaseEvent( QKeyEvent* );
	
	// Member Valiables
	bool m_bAuth;
	int  m_nID;
	bool m_bFirstTest;
	bool m_bSuspendMode;

protected slots:
	// SLOT Methos
	void accept();
	void receiveSysMessage( const QCString&, const QByteArray& );
};

#endif // _LESS_UNSATICEFACTORY_SCREENSAVER_PASS_INPUT_DLG_H_

