/*
	LUSScreenSaver Plugin Interface
	Copyright (C) 2004 ONO, Masayuki <mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _LESS_UNSATICEFACTORY_SCREENSAVER_INTERFACE_H_
#define _LESS_UNSATICEFACTORY_SCREENSAVER_INTERFACE_H_

#include <qpe/qcom.h>
#include <qwidget.h>

#ifndef QT_NO_COMPONENT
// {ebe84694-16c4-11d8-8c8a-ba30eeb48297}
#ifndef IID_LUSScreenSaver
#define IID_LUSScreenSaver QUuid( 0xebe84694, 0x16c4, 0x11d8, 0x8c, 0x8a, 0xba, 0x30, 0xee, 0xb4, 0x82, 0x97 )
#endif
#endif

class QWidget;

struct LUSScreenSaverInterface : public QUnknownInterface
{
	// for Initialize Mode
	enum {
		LUS_NORMAL,	// Normal Mode ( Module used for Screen Saving )
		LUS_PREVIEW	// Preview Mode ( Module used by Screen Saver Setting Dialog )
	};

	virtual	QWidget*	Init( int ) = 0;
	virtual	void		Start() = 0;
	virtual	void		Stop() = 0;
	virtual	QString		Name(){ return QString::null; }
	virtual QString		Version(){ return QString::null; }
	virtual QString		Comment(){ return QString::null; }
	virtual bool		CanCustomize(){ return FALSE; }
	virtual void		Setting() = 0;
};

#endif /* _LESS_UNSATICEFACTORY_SCREENSAVER_INTERFACE_H_ */
